///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

BOOL CALLBACK AddScheduleDialog(HWND xHandle, UINT xMessage, WPARAM wParam, LPARAM lParam)
{
	static HWND ScheduleDate_hWnd;
	static HWND ScheduleTime_hWnd;

	static HWND IncrementDayUD_hWnd;
	static HWND IncrementDay_hWnd;

	static HWND IncrementMinuteUD_hWnd;
	static HWND IncrementMinute_hWnd;

	static HWND IncrementHourUD_hWnd;
	static HWND IncrementHour_hWnd;

	if(xMessage == WM_INITDIALOG) // Received A Initilize Dialog Message
	{
		AddScheduleDialog_hWnd = xHandle;

		SendMessage(AddScheduleDialog_hWnd,(UINT)WM_SETTEXT,(WPARAM)0,(LPARAM)TitleCaption);
		SendMessage(AddScheduleDialog_hWnd,WM_SETICON,TRUE,(LPARAM)LoadIcon(MainInstance,MAKEINTRESOURCE(100)));

		ScheduleDate_hWnd	   = GetDlgItem(AddScheduleDialog_hWnd,1000);
		ScheduleTime_hWnd	   = GetDlgItem(AddScheduleDialog_hWnd,1001);

		IncrementDayUD_hWnd    = GetDlgItem(AddScheduleDialog_hWnd,2000);
		IncrementDay_hWnd	   = GetDlgItem(AddScheduleDialog_hWnd,2001);

		IncrementHourUD_hWnd   = GetDlgItem(AddScheduleDialog_hWnd,2002);
		IncrementHour_hWnd	   = GetDlgItem(AddScheduleDialog_hWnd,2003);

		IncrementMinuteUD_hWnd = GetDlgItem(AddScheduleDialog_hWnd,2004);
		IncrementMinute_hWnd   = GetDlgItem(AddScheduleDialog_hWnd,2005);


		SendMessage(IncrementDayUD_hWnd,(UINT)UDM_SETBUDDY,(WPARAM)IncrementDay_hWnd,(LPARAM)NULL);
		SendMessage(IncrementDayUD_hWnd,(UINT)UDM_SETRANGE,(WPARAM)NULL,(LPARAM)MAKELONG(7,0));

		SendMessage(IncrementHourUD_hWnd,(UINT)UDM_SETBUDDY,(WPARAM)IncrementHour_hWnd,(LPARAM)NULL);
		SendMessage(IncrementHourUD_hWnd,(UINT)UDM_SETRANGE,(WPARAM)NULL,(LPARAM)MAKELONG(23,0));

		SendMessage(IncrementMinuteUD_hWnd,(UINT)UDM_SETBUDDY,(WPARAM)IncrementMinute_hWnd,(LPARAM)NULL);
		SendMessage(IncrementMinuteUD_hWnd,(UINT)UDM_SETRANGE,(WPARAM)NULL,(LPARAM)MAKELONG(59,0));

		SetDlgItemInt(AddScheduleDialog_hWnd, 2001, 1, FALSE);
		SetDlgItemInt(AddScheduleDialog_hWnd, 2003, 0, FALSE);
		SetDlgItemInt(AddScheduleDialog_hWnd, 2005, 0, FALSE);

        BOD.Complete   = FALSE;
        SQLOD.Complete = FALSE;

        SetValues();

 		CenterWindow(AddScheduleDialog_hWnd);

		return 0;
	}


	if(xMessage == WM_COMMAND) // Received A Message
	{
		if(wParam == 100) //- Ok (Dialog Command)
		{
            if(BOD.Complete == FALSE)
            {
                MessageBox(AddScheduleDialog_hWnd, "You must set the backup options.", TitleCaption, MB_TASKMODAL);
                return 0;
            }

            if(SQLOD.Complete == FALSE)
            {
                MessageBox(AddScheduleDialog_hWnd, "You must set the SQL options.", TitleCaption, MB_TASKMODAL);
                return 0;
            }

            int IncrementMinute = CharInt( Get_Text(IncrementMinute_hWnd) );
            int IncrementHour   = CharInt( Get_Text(IncrementHour_hWnd) );
            int IncrementDay    = CharInt( Get_Text(IncrementDay_hWnd) );

            if(IncrementMinute == 0 && IncrementHour == 0 && IncrementDay == 0)
            {
                MessageBox(AddScheduleDialog_hWnd, "The scheduled backup must increment by some value. Day, Hour or minute.", TitleCaption, MB_TASKMODAL);
                return 0;
            }

            char TempValue[1024];

            int ThisSchedule = NextAvailSchedule();

			SYSTEMTIME Date;
			SYSTEMTIME Time;

			GetSystemTime(&Date);
			GetSystemTime(&Time);

			SendMessage(ScheduleDate_hWnd, MCM_GETCURSEL, (WPARAM) 0, (LPARAM) (LPSYSTEMTIME) &Date);
            SendMessage(ScheduleTime_hWnd, MCM_GETCURSEL, (WPARAM) 0, (LPARAM) (LPSYSTEMTIME) &Time);

            BT[ThisSchedule].SQLServer        = SQLOD.SQLServer;
            BT[ThisSchedule].Database         = SQLOD.DataBase;
            BT[ThisSchedule].DBDriver         = SQLOD.DBDriver;
            BT[ThisSchedule].Username         = SQLOD.UserName;
            BT[ThisSchedule].Password         = SQLOD.Password;
            BT[ThisSchedule].IsTrusted        = SQLOD.IsTrusted;

            BT[ThisSchedule].Name             = BOD.BackupName;
            BT[ThisSchedule].Description      = BOD.BackupDescription;
            BT[ThisSchedule].Filename         = BOD.BackupFileName;

            BT[ThisSchedule].BackupTime       = TimeToLong(Time.wHour, Time.wMinute, Time.wSecond);
            BT[ThisSchedule].BackupDate       = DateToLong(Date.wYear, Date.wMonth,  Date.wDay);
            BT[ThisSchedule].IncrementDay     = IncrementDay;
            BT[ThisSchedule].IncrementHour    = IncrementHour;
            BT[ThisSchedule].IncrementMinute  = IncrementMinute;
            BT[ThisSchedule].ScheduleID       = CurrentScheduleID++;

            sprintf(TempValue, "%d", BT[ThisSchedule].ScheduleID);
            SD.LVItem.pszText  = TempValue;
            SD.LVItem.mask     = LVIF_TEXT;
            SD.LVItem.iSubItem = 0;
            ListView_InsertItem(SD.ListView_hWnd,&SD.LVItem);

            SD.LVItem.pszText  = BT[ThisSchedule].Name;
            SD.LVItem.mask     = LVIF_TEXT;
            SD.LVItem.iSubItem = 1;
            ListView_SetItem(SD.ListView_hWnd,&SD.LVItem);

            SD.LVItem.pszText  = BT[ThisSchedule].Description;
            SD.LVItem.mask     = LVIF_TEXT;
            SD.LVItem.iSubItem = 2;
            ListView_SetItem(SD.ListView_hWnd,&SD.LVItem);

            GetDateFormat(NULL, NULL, &Date, "MM-dd-yyyy", TempValue, 1024);
            SD.LVItem.pszText  = TempValue;
            SD.LVItem.mask     = LVIF_TEXT;
            SD.LVItem.iSubItem = 3;
            ListView_SetItem(SD.ListView_hWnd,&SD.LVItem);

            GetTimeFormat(LOCALE_USER_DEFAULT, TIME_NOSECONDS, &Time, NULL, TempValue, 1024);
            SD.LVItem.pszText  = TempValue;
            SD.LVItem.mask     = LVIF_TEXT;
            SD.LVItem.iSubItem = 4;
            ListView_SetItem(SD.ListView_hWnd,&SD.LVItem);

            SD.LVItem.pszText  = BT[ThisSchedule].Database;
            SD.LVItem.mask     = LVIF_TEXT;
            SD.LVItem.iSubItem = 5;
            ListView_SetItem(SD.ListView_hWnd,&SD.LVItem);

            SD.LVItem.pszText  = BT[ThisSchedule].Filename;
            SD.LVItem.mask     = LVIF_TEXT;
            SD.LVItem.iSubItem = 6;
            ListView_SetItem(SD.ListView_hWnd,&SD.LVItem);

//          FixSchedule(ThisSchedule);

            BT[ThisSchedule].Active           = TRUE;
            BT[ThisSchedule].ScheduleSet      = TRUE;

            NumberOfSetSchedules++;

			EndDialog(AddScheduleDialog_hWnd,0);

			return 0;
		}

		if(wParam==101) //- Cancel (Dialog Command)
		{
			EndDialog(AddScheduleDialog_hWnd,0);
			return 0;
		}

		if(wParam==102) //- Backup Options (Dialog Command)
		{
        	DialogBox(MainInstance, MAKEINTRESOURCE(106), AddScheduleDialog_hWnd, AddBackupOptionsDialog);
			return 0;
		}

		if(wParam==103) //- SQL Options (Dialog Command)
		{
        	DialogBox(MainInstance, MAKEINTRESOURCE(107), AddScheduleDialog_hWnd, AddSQLOptionsDialog);
			return 0;
		}

		return 0;
	}

	return 0;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

