///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

BOOL CALLBACK EditScheduleDialog(HWND xHandle, UINT xMessage, WPARAM wParam, LPARAM lParam)
{
	static HWND ScheduleDate_hWnd;
	static HWND ScheduleTime_hWnd;

	static HWND IncrementDayUD_hWnd;
	static HWND IncrementDay_hWnd;

	static HWND IncrementMinuteUD_hWnd;
	static HWND IncrementMinute_hWnd;

	static HWND IncrementHourUD_hWnd;
	static HWND IncrementHour_hWnd;

	if(xMessage == WM_INITDIALOG) // Received A Initilize Dialog Message
	{
		EditScheduleDialog_hWnd = xHandle;

		SendMessage(EditScheduleDialog_hWnd,(UINT)WM_SETTEXT,(WPARAM)0,(LPARAM)TitleCaption);
		SendMessage(EditScheduleDialog_hWnd,WM_SETICON,TRUE,(LPARAM)LoadIcon(MainInstance,MAKEINTRESOURCE(100)));

		ScheduleDate_hWnd	   = GetDlgItem(EditScheduleDialog_hWnd,1000);
		ScheduleTime_hWnd	   = GetDlgItem(EditScheduleDialog_hWnd,1001);

		IncrementDayUD_hWnd    = GetDlgItem(EditScheduleDialog_hWnd,2000);
		IncrementDay_hWnd	   = GetDlgItem(EditScheduleDialog_hWnd,2001);

		IncrementHourUD_hWnd   = GetDlgItem(EditScheduleDialog_hWnd,2002);
		IncrementHour_hWnd	   = GetDlgItem(EditScheduleDialog_hWnd,2003);

		IncrementMinuteUD_hWnd = GetDlgItem(EditScheduleDialog_hWnd,2004);
		IncrementMinute_hWnd   = GetDlgItem(EditScheduleDialog_hWnd,2005);

		SendMessage(IncrementDayUD_hWnd,(UINT)UDM_SETBUDDY,(WPARAM)IncrementDay_hWnd,(LPARAM)NULL);
		SendMessage(IncrementDayUD_hWnd,(UINT)UDM_SETRANGE,(WPARAM)NULL,(LPARAM)MAKELONG(7,0));

		SendMessage(IncrementHourUD_hWnd,(UINT)UDM_SETBUDDY,(WPARAM)IncrementHour_hWnd,(LPARAM)NULL);
		SendMessage(IncrementHourUD_hWnd,(UINT)UDM_SETRANGE,(WPARAM)NULL,(LPARAM)MAKELONG(23,0));

		SendMessage(IncrementMinuteUD_hWnd,(UINT)UDM_SETBUDDY,(WPARAM)IncrementMinute_hWnd,(LPARAM)NULL);
		SendMessage(IncrementMinuteUD_hWnd,(UINT)UDM_SETRANGE,(WPARAM)NULL,(LPARAM)MAKELONG(59,0));

		SetDlgItemInt(EditScheduleDialog_hWnd, 2001, BT[ESD.EditItem].IncrementDay,    FALSE);
		SetDlgItemInt(EditScheduleDialog_hWnd, 2003, BT[ESD.EditItem].IncrementHour,   FALSE);
		SetDlgItemInt(EditScheduleDialog_hWnd, 2005, BT[ESD.EditItem].IncrementMinute, FALSE);

        SYSTEMTIME ST;

        GetLocalTime(&ST);

    	int Year, Month,  Day;
		LongToDate(BT[ESD.EditItem].BackupDate, &Year, &Month,  &Day);
		ST.wYear   = Year;
		ST.wMonth  = Month;
		ST.wDay    = Day;

		int Hour, Minute, Second;
		LongToTime(BT[ESD.EditItem].BackupTime, &Hour, &Minute, &Second);
		ST.wHour   = Hour;
		ST.wMinute = Minute;
		ST.wSecond = Second;

		SendMessage(ScheduleDate_hWnd, MCM_SETCURSEL, (WPARAM) 0, (LPARAM) (LPSYSTEMTIME) &ST);
        SendMessage(ScheduleTime_hWnd, MCM_SETCURSEL, (WPARAM) 0, (LPARAM) (LPSYSTEMTIME) &ST);

        BOD.Complete   = FALSE;
        SQLOD.Complete = FALSE;

        EnableWindow( GetDlgItem(EditScheduleDialog_hWnd, 101), FALSE);

 		CenterWindow(EditScheduleDialog_hWnd);

		return 0;
	}


	if(xMessage == WM_COMMAND) // Received A Message
	{
		if(wParam == 100) //- Ok (Dialog Command)
		{
            int IncrementMinute = CharInt( Get_Text(IncrementMinute_hWnd) );
            int IncrementHour   = CharInt( Get_Text(IncrementHour_hWnd) );
            int IncrementDay    = CharInt( Get_Text(IncrementDay_hWnd) );

            if(IncrementMinute == 0 && IncrementHour == 0 && IncrementDay == 0)
            {
                MessageBox(EditScheduleDialog_hWnd, "The scheduled backup must increment by some value. Day, Hour or minute.", TitleCaption, MB_TASKMODAL);
                return 0;
            }

			SYSTEMTIME Date;
			SYSTEMTIME Time;

			GetSystemTime(&Date);
			GetSystemTime(&Time);

			SendMessage(ScheduleDate_hWnd, MCM_GETCURSEL, (WPARAM) 0, (LPARAM) (LPSYSTEMTIME) &Date);
            SendMessage(ScheduleTime_hWnd, MCM_GETCURSEL, (WPARAM) 0, (LPARAM) (LPSYSTEMTIME) &Time);

            if(SQLOD.Complete == TRUE)
            {
                BT[ESD.EditItem].SQLServer        = SQLOD.SQLServer;
                BT[ESD.EditItem].Database         = SQLOD.DataBase;
                BT[ESD.EditItem].DBDriver         = SQLOD.DBDriver;
                BT[ESD.EditItem].Username         = SQLOD.UserName;
                BT[ESD.EditItem].Password         = SQLOD.Password;
            }

            if(BOD.Complete == TRUE)
            {
                BT[ESD.EditItem].Name             = BOD.BackupName;
                BT[ESD.EditItem].Description      = BOD.BackupDescription;
                BT[ESD.EditItem].Filename         = BOD.BackupFileName;
            }

            BT[ESD.EditItem].BackupTime       = TimeToLong(Time.wHour, Time.wMinute, Time.wSecond);
            BT[ESD.EditItem].BackupDate       = DateToLong(Date.wYear, Date.wMonth,  Date.wDay);
            BT[ESD.EditItem].IncrementDay     = IncrementDay;
            BT[ESD.EditItem].IncrementHour    = IncrementHour;
            BT[ESD.EditItem].IncrementMinute  = IncrementMinute;
//          BT[ESD.EditItem].ScheduleID       = CurrentScheduleID++;

//          FixSchedule(ESD.EditItem);

//          BT[ESD.EditItem].Active           = TRUE;
//          BT[ESD.EditItem].ScheduleSet      = TRUE;

            ListView_DeleteAllItems(SD.ListView_hWnd);
            LoadScheduleIntoDailog();

			EndDialog(EditScheduleDialog_hWnd,0);

			return 0;
		}

		if(wParam==102) //- Backup Options (Dialog Command)
		{
        	DialogBox(MainInstance, MAKEINTRESOURCE(106), EditScheduleDialog_hWnd, EditBackupOptionsDialog);
			return 0;
		}

		if(wParam==103) //- SQL Options (Dialog Command)
		{
        	DialogBox(MainInstance, MAKEINTRESOURCE(107), EditScheduleDialog_hWnd, EditSQLOptionsDialog);
			return 0;
		}

		return 0;
	}

	return 0;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

