////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

int SaveScheduleToDataBase(HWND ListView_hWnd)
{
    int LocalLoop     = 0;
    char *ColumbName  = NULL;

    _DataDaseSystem DBS;

	InitializeDBS(&DBS, 20, MaxSchedules + 1);

    ColumbName = "NonSchedInfo";
    AddColumb(&DBS, ColumbName, strlen(ColumbName));

    ColumbName = "Name";
    AddColumb(&DBS, ColumbName, strlen(ColumbName));
    ColumbName = "Filename";
    AddColumb(&DBS, ColumbName, strlen(ColumbName));
    ColumbName = "Description";
    AddColumb(&DBS, ColumbName, strlen(ColumbName));

    ColumbName = "SQLServer";
    AddColumb(&DBS, ColumbName, strlen(ColumbName));
    ColumbName = "Database";
    AddColumb(&DBS, ColumbName, strlen(ColumbName));
    ColumbName = "DBDriver";
    AddColumb(&DBS, ColumbName, strlen(ColumbName));
    ColumbName = "Username";
    AddColumb(&DBS, ColumbName, strlen(ColumbName));
    ColumbName = "Password";
    AddColumb(&DBS, ColumbName, strlen(ColumbName));
    ColumbName = "IsTrusted";
    AddColumb(&DBS, ColumbName, strlen(ColumbName));

    ColumbName = "BackupDate";
    AddColumb(&DBS, ColumbName, strlen(ColumbName));
    ColumbName = "BackupTime";
    AddColumb(&DBS, ColumbName, strlen(ColumbName));

    ColumbName = "IncrementDay";
    AddColumb(&DBS, ColumbName, strlen(ColumbName));
    ColumbName = "IncrementHour";
    AddColumb(&DBS, ColumbName, strlen(ColumbName));
    ColumbName = "IncrementMinute";
    AddColumb(&DBS, ColumbName, strlen(ColumbName));

    ColumbName = "ScheduleID";
    AddColumb(&DBS, ColumbName, strlen(ColumbName));
    ColumbName = "Active";
    AddColumb(&DBS, ColumbName, strlen(ColumbName));

    ColumbName = "Reserved";
    AddColumb(&DBS, ColumbName, strlen(ColumbName));

    AddEntryByColumbName(&DBS, "NonSchedInfo", (char *) &NumberOfSetSchedules, sizeof(int));
    AddEntryByColumbName(&DBS, "NonSchedInfo", (char *) &CurrentScheduleID, sizeof(DWORD));

    while(LocalLoop < MaxSchedules)
    {
        if(BT[LocalLoop].ScheduleSet == TRUE)
        {
            AddEntryByColumbName(&DBS, "Name", BT[LocalLoop].Name, strlen(BT[LocalLoop].Name));
            AddEntryByColumbName(&DBS, "Filename", BT[LocalLoop].Filename, strlen(BT[LocalLoop].Filename));
            AddEntryByColumbName(&DBS, "Description", BT[LocalLoop].Description, strlen(BT[LocalLoop].Description));

            AddEntryByColumbName(&DBS, "SQLServer", BT[LocalLoop].SQLServer, strlen(BT[LocalLoop].SQLServer));
            AddEntryByColumbName(&DBS, "Database", BT[LocalLoop].Database, strlen(BT[LocalLoop].Database));
            AddEntryByColumbName(&DBS, "DBDriver", BT[LocalLoop].DBDriver, strlen(BT[LocalLoop].DBDriver));
            AddEntryByColumbName(&DBS, "Username", BT[LocalLoop].Username, strlen(BT[LocalLoop].Username));
            AddEntryByColumbName(&DBS, "Password", BT[LocalLoop].Password, strlen(BT[LocalLoop].Password));
            AddEntryByColumbName(&DBS, "IsTrusted", (char *) &BT[LocalLoop].IsTrusted, sizeof(BOOL));

            AddEntryByColumbName(&DBS, "BackupDate", (char *) &BT[LocalLoop].BackupDate, sizeof(DWORD));
            AddEntryByColumbName(&DBS, "BackupTime", (char *) &BT[LocalLoop].BackupTime, sizeof(DWORD));

            AddEntryByColumbName(&DBS, "ScheduleID", (char *) &BT[LocalLoop].ScheduleID, sizeof(DWORD));

            AddEntryByColumbName(&DBS, "IncrementDay", (char *) &BT[LocalLoop].IncrementDay, sizeof(WORD));
            AddEntryByColumbName(&DBS, "IncrementHour", (char *) &BT[LocalLoop].IncrementHour, sizeof(WORD));
            AddEntryByColumbName(&DBS, "IncrementMinute", (char *) &BT[LocalLoop].IncrementMinute, sizeof(WORD));

            AddEntryByColumbName(&DBS, "Active", (char *) &BT[LocalLoop].Active, sizeof(BOOL));
        }

        LocalLoop++;
    }

    if(WriteDBFile(&DBS, SavedDataFile) == FALSE)
        return 0;

	return 0;
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

int ReadDataBaseToSchedule(void)
{
    _DataDaseSystem DBS;
    int LocalLoop = 0;

    if(ReadDBFile(&DBS, SavedDataFile) == FALSE)
        return FALSE;

    RetreiveDataByColumbName(&DBS, "NonSchedInfo", 0, (char *) &NumberOfSetSchedules);
    RetreiveDataByColumbName(&DBS, "NonSchedInfo", 1, (char *) &CurrentScheduleID);

    while(LocalLoop < NumberOfSetSchedules)
    {
        BT[LocalLoop].Name        = (char *) calloc(1024, 1);
        BT[LocalLoop].Description = (char *) calloc(256, 1);
        BT[LocalLoop].Filename    = (char *) calloc(256, 1);

        BT[LocalLoop].SQLServer = (char *) calloc(256, 1);
        BT[LocalLoop].Database  = (char *) calloc(256, 1);
        BT[LocalLoop].DBDriver  = (char *) calloc(256, 1);
        BT[LocalLoop].Username  = (char *) calloc(256, 1);
        BT[LocalLoop].Password  = (char *) calloc(256, 1);

        RetreiveDataByColumbName(&DBS, "Name", LocalLoop, BT[LocalLoop].Name);
        RetreiveDataByColumbName(&DBS, "Description", LocalLoop, BT[LocalLoop].Description);
        RetreiveDataByColumbName(&DBS, "Filename", LocalLoop, BT[LocalLoop].Filename);

        RetreiveDataByColumbName(&DBS, "SQLServer", LocalLoop, BT[LocalLoop].SQLServer);
        RetreiveDataByColumbName(&DBS, "Database", LocalLoop, BT[LocalLoop].Database);
        RetreiveDataByColumbName(&DBS, "DBDriver", LocalLoop, BT[LocalLoop].DBDriver);
        RetreiveDataByColumbName(&DBS, "Username", LocalLoop, BT[LocalLoop].Username);
        RetreiveDataByColumbName(&DBS, "Password", LocalLoop, BT[LocalLoop].Password);
        RetreiveDataByColumbName(&DBS, "IsTrusted", LocalLoop, (char *) &BT[LocalLoop].IsTrusted);

        RetreiveDataByColumbName(&DBS, "BackupDate", LocalLoop, (char *) &BT[LocalLoop].BackupDate);
        RetreiveDataByColumbName(&DBS, "BackupTime", LocalLoop, (char *) &BT[LocalLoop].BackupTime);

        RetreiveDataByColumbName(&DBS, "ScheduleID", LocalLoop, (char *) &BT[LocalLoop].ScheduleID);

        RetreiveDataByColumbName(&DBS, "IncrementDay", LocalLoop, (char *) &BT[LocalLoop].IncrementDay);
        RetreiveDataByColumbName(&DBS, "IncrementHour", LocalLoop, (char *) &BT[LocalLoop].IncrementHour);
        RetreiveDataByColumbName(&DBS, "IncrementMinute", LocalLoop, (char *) &BT[LocalLoop].IncrementMinute);

        RetreiveDataByColumbName(&DBS, "Active", LocalLoop, (char *) &BT[LocalLoop].Active);

        BT[LocalLoop].ScheduleSet = TRUE;

        LocalLoop++;
    }

	return 0;
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

