///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

BOOL LoadDBListBox(HWND DBListBox_hWnd)
{
    HSTMT fstmt;

    if(OpenDB(MasterDriver, MasterServer, MasterUID, MasterPWS, MasterDatabase) == FALSE)
    {
        ErrorMessage(JID.Dialog_hWnd, "Failed to connect to local master database");
        return FALSE;
    }

    SQLCHAR szName[50];
    SQLINTEGER cbName;

    SQLRETURN Result;

    if(!DBexecute("Select name from SysDataBases", &fstmt))
        printf("Exe Failed.\n");
    else printf("Exe passed.\n\n");

    while(TRUE)
    {
        Result = SQLFetch(fstmt);
        if(Result == SQL_ERROR)
        {
            printf("Fetch error\n");
            return FALSE;
        }

        if(Result == SQL_SUCCESS || Result == SQL_SUCCESS_WITH_INFO)
        {
            SQLGetData(fstmt, 1, SQL_C_CHAR, szName, 50, &cbName);

            InsertListBoxItem(DBListBox_hWnd, (char *)szName, -1);

            printf("%s\n", szName);
        }
        else break;
    }


    DBclose();
	return TRUE;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

DWORD WINAPI DialogThread(LPVOID xData)
{
    if(DisplaySplash)
    {
    	DialogBox(MainInstance, MAKEINTRESOURCE(103), NULL, SplashDialog);
        Sleep(500);
    }

	DialogBox(MainInstance, MAKEINTRESOURCE(100), NULL, MainDialog);
    EndApplication = TRUE;
    return 0;
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

int Get_LVFocusItem(HWND ListBox)
{
    int ItemCount = ListView_GetItemCount(ListBox);
    int LocalLoop = 0;

    while(LocalLoop < ItemCount)
    {
        if( ListView_GetItemState(ListBox, LocalLoop, LVIS_FOCUSED) )
            return LocalLoop;

        LocalLoop++;
    }

	return -1;
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

BOOL OpenLogFile(void)
{
    if( (LogFileHandle = fopen (LogFileName, "a+")) == NULL)
        return FALSE;

    return TRUE;
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void WriteToLog(char *xMessage)
{
    fprintf(LogFileHandle, "%s\r\n", xMessage);
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CloseLogFile(void)
{
    if(LogFileHandle) fclose(LogFileHandle);
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void LBWrite(HWND ListBox_hWnd, char *xMessage)
{
    InsertListBoxItem(ListBox_hWnd, xMessage, -1);
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

