#ifndef _DEFINED_NetWorkDLS_New_Technology_Database_System_Header
#define _DEFINED_NetWorkDLS_New_Technology_Database_System_Header
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#define DllImport         extern "C" __declspec( dllimport )

#define MAXDATASIZE      1048576
#define MAXROWSPERCOLUMB 1000000
#define MAXCOLUMBS       1000000
#define MINROWSPERCOLUMB 1
#define MINCOLUMBS       1

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

struct _DBSColumb{
    char **Row;     // Row Data              | Row[Row]      = "Row Data";
    int *Length;    // Length to row data    | Length[Row]   = 9;

    char *Name;     // Name of columb        | Name          = "Columb Name";
    int NameLength; // Length of columb name | NameLength    = 11;
    int Rows;       // Rows in this columb   | Rows          = 1255;
};

struct _DataDaseSystem{
    int MaxRowsPerColumb; //- Max rows per columb    | MaxRowsPerColumb = 1000;
    int MaxColumbs;       //- Max columbs            | MaxColumbs       = 100
    int Columbs;          //- Current columbs in DB  | Columbs          = 57;
    _DBSColumb *Columb;   //- Columbs structure      | Columb[Columb Number]
};

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

DllImport int InitializeDBS(struct _DataDaseSystem *, int, int);
DllImport int FreeDBS(struct _DataDaseSystem *);

DllImport int AddColumb(struct _DataDaseSystem *, char *, int);
DllImport int ColumbNameToColumbPosition(struct _DataDaseSystem *, char *);
DllImport int GetMostRows(struct _DataDaseSystem *);

DllImport int DeleteRowByColumbPosition(struct _DataDaseSystem *, int, int);
DllImport int DeleteRowByColumbName(struct _DataDaseSystem *, char *, int);

DllImport int AddEntryByColumbPosition(struct _DataDaseSystem *, int, char *, int);
DllImport int AddEntryByColumbName(struct _DataDaseSystem *, char *, char *, int);

DllImport int RetreiveDataLengthByColumbPosition(struct _DataDaseSystem *, int, int);
DllImport int RetreiveDataLengthByColumbName(struct _DataDaseSystem *, char *, int);

DllImport int SearchRowDataByColumbPosition(struct _DataDaseSystem *, int, char *);
DllImport int SearchRowDataByColumbName(struct _DataDaseSystem *, char *, char *);

DllImport int RetreiveDataByColumbPosition(struct _DataDaseSystem *, int, int, char *);
DllImport int RetreiveDataByColumbName(struct _DataDaseSystem *, char *, int, char *);

DllImport BOOL ReadDBFile(struct _DataDaseSystem *, char *);
DllImport BOOL WriteDBFile(struct _DataDaseSystem *, char *);

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#endif

